# class CSV::Builder

- CSV::Builder
- Reference
- Object

##
Overview

A CSV Builder writes CSV to an `IO`.

    require "csv"

    result = CSV.build do |csv|
      # A row can be written by specifying several values
      csv.row "Hello", 1, 'a', "String with \"quotes\"", '"', :sym

      # Or an enumerable
      csv.row [1, 2, 3]

      # Or using a block, and appending to the row
      csv.row do |row|
        # Appending a single value
        row << 4

        # Or multiple values
        row.concat 5, 6

        # Or an enumerable
        row.concat [7, 8]
      end
    end
    puts result

Output:

    Hello,1,a,"String with ""quotes""","""",sym
    1,2,3
    4,5,6,7,8

##
Defined in:

csv/builder.cr

##
Constructors

- .new(io : IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, quoting : Quoting = Quoting::RFC)

  Creates a builder that will write to the given `IO`.

##
Instance Method Summary

- #row(&)

  Yields a `CSV::Builder::Row` to append a row.

- #row(values : Enumerable) : Nil

  Appends the given values as a single row, and then a newline.

- #row(*values) : Nil

  Appends the given values as a single row, and then a newline.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(io : IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, quoting : Quoting = Quoting::RFC) #

Creates a builder that will write to the given `IO`.

##
Instance Method Detail

def row(&) #

Yields a `CSV::Builder::Row` to append a row. A newline is appended to `IO` after the block exits.

def row(values : Enumerable) : Nil #

Appends the given values as a single row, and then a newline.

def row(*values) : Nil #

Appends the given values as a single row, and then a newline.